{ Binris keresfa }
program BINKERFA;
uses crt;
type
  Elem=integer;
  BinFaPontMut=^BinFaPont;
  BinFaPont=record
    PontJell:Elem;
    BalAg,JobbAg:BinFaPontMut;
  end;

{ Keress binris keresfban }
function Keres(Gyoker:BinFaPontMut; x:Elem):BinFaPontMut;
var Akt:BinFaPontMut;
begin
  Akt:=Gyoker;
  while (Akt<>NIL) and (x<>Akt^.PontJell) do
    if x<Akt^.PontJell then
      Akt:=Akt^.BalAg
    else
      Akt:=Akt^.JobbAg;
  Keres:=Akt;
end;

{ Binris keresfa bvtse }
procedure Bovit(var Gyoker:BinFaPontMut; x:BinFaPontMut);
var Akt,Szulo:BinFaPontMut;
begin
  if Gyoker=NIL then
    Gyoker:=x
  else begin
    { Helykeress }
    Akt:=Gyoker; Szulo:=NIL;
    while Akt<>NIL do begin
      Szulo:=Akt;
      if x^.PontJell<Akt^.PontJell then
	Akt:=Akt^.BalAg
      else
	Akt:=Akt^.JobbAg;
    end;
    { Beilleszts }
    if x^.PontJell<Szulo^.PontJell then
      Szulo^.BalAg:=x
    else
      Szulo^.JobbAg:=x;
  end;
end;

{ Binris keresfa elemeinek kirsa }
procedure Kiir(Gyoker:BinFaPontMut);
begin
  if Gyoker<>NIL then begin
    { Rekurzv hvs a bal gra }
    Kiir(Gyoker^.BalAg);
    { A gykrponthoz tartoz rtk kirsa }
    write(Gyoker^.PontJell,' ');
    { Rekurzv hvs a bal gra }
    Kiir(Gyoker^.JobbAg);
  end;
end;

var Gyoker,Akt:BinFaPontMut; a:Elem; i:integer;
begin
  clrscr;
  Gyoker:=NIL;
  writeln('Adatmegads vge:0');
  i:=1;
  repeat
    write(i,'. elem:'); inc(i); readln(a);
    if a<>0 then begin
      if sizeof(BinFaPont)<=maxavail then begin
	{ Van hely, a keresfba illesszk }
        new(Akt);
	with Akt^ do begin
          PontJell:=a; BalAg:=NIL; JobbAg:=NIL;
        end;
	Bovit(Gyoker,Akt);
      end;
    end;
  until a=0;

  writeln('A megadott elemek rendezve:');
  Kiir(Gyoker);
  writeln;

  write('A keresett elem:'); readln(a);
  if Keres(Gyoker,a)=NIL then
    writeln('Nincs ilyen elem!')
  else
    writeln('Van ilyen elem!');
end.
