{ Ellenrztt input }
program ELLINP;
uses crt;
const
  Sotet=0;                  { A sznkiemelshez }
  Vilagos=7;
  Kilep=#27;                { Esc }        { Vezrlbillentyk }
  AdatVeg=#13;              { Enter }
  Torol=#8;                 { Backspace }

  MaxRszHossz=6;            { A rendszm maximlis hossza }
  MaxEgSzHossz=11;          { Az egsz szm maximlis hossza }
  Elojel='-';               { Eljel }

  SzamJegyek=['0'..'9'];    { A szmjegyek halmaza }

type
  Jelek=set of char;

function BillBe(Normal,Dupla:Jelek; var Duplae:Boolean):char;
var Jel:char; JoJel:boolean;
begin
  repeat
    Jel:=readkey; Duplae:=Jel=#0;
    if Duplae then begin
      Jel:=readkey;
      JoJel:=Jel in Dupla;
    end else
      JoJel:=Jel in Normal;
  until JoJel;
  BillBe:=Jel;
end;

function JelBe(JoJelek:Jelek):char;
var Duplae:boolean;
begin
  JelBe:=BillBe(JoJelek,[],Duplae);
end;

function JobbTolt(Mit:string; Hossz:byte):string;
begin
  while length(Mit)<Hossz do Mit:=Mit+' ';
  JobbTolt:=Mit;
end;

procedure NormalIr;
begin
  textcolor(Vilagos); textbackground(Sotet);
end;

procedure InverzIr;
begin
  textcolor(Sotet); textbackground(Vilagos);
end;

procedure Ir(Mit:string; Oszl,Sor:byte);
begin
  if Oszl=0 then Oszl:=wherex;
  if Sor=0 then Sor:=wherey;
  gotoxy(Oszl,Sor); write(Mit);
end;

procedure KiIras(Mit:string; Oszl,Sor,Hossz:byte);
begin
  Ir(Mit,Oszl,Sor); gotoxy(Oszl+Hossz,Sor);
end;

procedure RendSzamBe(var RendSzam:string;   { i/o eredmny szveg  }
                         Oszl,Sor:byte;     { i   kpernypozci  }
                     var VanAdat:boolean    { o   van-e j adat    });
const
  Betuk=['A'..'Z','a'..'z']; AdatJel=Betuk+SzamJegyek;
var
  Jel:char; JoJel:Jelek; Hossz:byte;
begin
  {Elkszts}
  {Adat}
  Hossz:=length(RendSzam); RendSzam:=JobbTolt(RendSzam,MaxRszHossz);
  {Kperny}
  if Oszl=0 then Oszl:=wherex;
  if Sor=0 then Sor:=wherey;
  InverzIr;
  KiIras(RendSzam,Oszl,Sor,Hossz);
  {Beolvass}
  repeat
    {JoJel bellts}
    JoJel:=[KiLep];
    case Hossz of
      0..1: JoJel:=JoJel+Betuk;
         2: JoJel:=JoJel+AdatJel;
      3..5: JoJel:=JoJel+SzamJegyek;
    end;
    if Hossz>0 then JoJel:=JoJel+[Torol];
    {Utols szmjegy}
    if (Hossz=5) and (RendSzam[3] in Betuk+['0']) and
       (copy(RendSzam,4,2)='00') then JoJel:=JoJel-['0'];
    if Hossz=MaxRszHossz then JoJel:=JoJel+[AdatVeg];
    {Jel beolvass}
    Jel:=JelBe(JoJel);
    {Jel feldolgozs}
    if Jel in AdatJel then begin
      {Nagybetss alaktjuk}
      inc(Hossz); RendSzam[Hossz]:=upcase(Jel)
    end else
    if Jel=Torol then begin
      RendSzam[Hossz]:=' '; dec(Hossz);
    end;
    KiIras(RendSzam,Oszl,Sor,Hossz);
  until (Jel in [KiLep,AdatVeg]);
  {Befejezs}
  VanAdat:=Jel<>KiLep;
  {Inverz kiemels levtele}
  NormalIr;
  KiIras(JobbTolt('',MaxRszHossz),Oszl,Sor,MaxRszHossz);
  {Hosszbellts}
  if VanAdat then RendSzam[0]:=chr(Hossz)
  else RendSzam:='';
  KiIras(RendSzam,Oszl,Sor,Hossz);
 end;

procedure EgSzamBe(var SzamSzov:string;     { i/o eredmny szveg  }
	               Oszl,Sor:byte;       { i   kpernypozci  }
                       Tol,Ig:longint;      { i   hatrok          }
	           var VanAdat:boolean;     { o   van-e j adat    }
	           var SzamErt:longint      { o   az eredmny szm });
var
  Jel:char; JoJel:Jelek; Hossz,MaxH:byte; JoAdat:boolean;
  w:string; x:real; i:integer;
begin
  {Elkszts}
  {Adat}
  str(Tol,w); MaxH:=length(w); str(Ig,w);
  if MaxH<length(w) then MaxH:=length(w);
  Hossz:=length(SzamSzov); SzamSzov:=JobbTolt(SzamSzov,MaxH);
  {Kperny}
  if Oszl=0 then Oszl:=wherex;
  if Sor=0 then Sor:=wherey;
  InverzIr;
  KiIras(SzamSzov,Oszl,Sor,Hossz);
  {Beolvass}
  repeat
    {Tartalmi helyessg: Tol-Ig }
    repeat
      {Formai helyessg: csak szm}
      {Jojel bellts}
      JoJel:=[KiLep];
      if Hossz<MaxH then JoJel:=JoJel+SzamJegyek;
      if (Hossz=0) and (Tol<0) then JoJel:=JoJel+[Elojel];
      if Hossz>0 then JoJel:=JoJel+[Torol];
      if (Hossz>0) and (SzamSzov[Hossz] in SzamJegyek) then
        JoJel:=JoJel+[AdatVeg];
      {Jel beolvass}
      Jel:=JelBe(JoJel);
      {Jel feldolgozs}
      if (Jel in SzamJegyek) or (Jel=Elojel) then begin
        Hossz:=Hossz+1; SzamSzov[Hossz]:=Jel
      end else
      if Jel=Torol then begin
        SzamSzov[Hossz]:=' '; Hossz:=Hossz-1;
      end;
      KiIras(SzamSzov,Oszl,Sor,Hossz);
    until Jel in [KiLep,AdatVeg];
    {Tartomny ellenrzs}
    if Jel<>KiLep then begin
      val(copy(SzamSzov,1,Hossz),x,i) ;
      JoAdat:=(x>=Tol) and (x<=Ig);
    end;
  until (Jel=KiLep) or JoAdat;
  {Befejezs}
  VanAdat:=Jel<>KiLep;
  {Inverz kiemels levtele}
  NormalIr;
  KiIras(JobbTolt('',MaxH),Oszl,Sor,MaxH);
  {Hosszbellts}
  if VanAdat then begin
    SzamSzov[0]:=chr(Hossz);
    SzamErt:=round(x);
  end
  else SzamSzov:='';
  KiIras(SzamSzov,Oszl,Sor,Hossz);
end;

var st:string; van:boolean; l:longint;
begin
  NormalIr; clrscr;

  st:='';
  write('Rendszm:');
  RendszamBe(st,0,0,van);
  writeln;
  if van then
    writeln('A megadott rendszm:',st)
  else
    writeln('Nem adott meg adatot!');
  writeln;

  st:='';
  write('Egsz szm [-128,127]:');
  EgSzamBe(st,0,0,-128,127,van,l);
  writeln;
  if van then begin
    writeln('A megadott szm sztringknt:',st);
    writeln('A megadott szm szmknt:',l);
  end else
    writeln('Nem adott meg adatot!');
end.