/* GYRENDR.C : Gyorsrendezs rekurzvan */

#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define MaxElemSzam 10            /* A rendezend adatok maximlis szma */
#define MaxElem 20                /* A generland adatok maximlis rtke */

typedef int Elem;                 /* A rendezend elemek tpusa */
typedef Elem Tomb[MaxElemSzam];   /* A rendezend elemek tmbje */

/* A rekurzv eljrs amely rendezi az 'a' tmb 'k'-'v' index elemeit */
void GyorsRend(Tomb a, int k, int v)
{ Elem s,cs; int i,j;
  if (k<v) {
    /* Van legalbb kt elem */
    i=k; j=v; s=a[(i+j)/2];
    /* Sztvlogats a strzsa (s) elemhez kpest */
    while (i<=j) {
      while (a[i]<s) i++;
      while (a[j]>s) j--;
      if (i<=j) {
	/* Az i. s j. elemek cserje */
	cs=a[i]; a[i]=a[j]; a[j]=cs;
	i++; j--;
      }
    }
    /* Az els rsz rendezse rekurzv hvssal */
    GyorsRend(a,k,j);
    /* A msodik rsz rendezse rekurzv hvssal */
    GyorsRend(a,i,v);
  }
}

/* Elemek generlsa */
void General(Tomb a, int n)
{ int i;
  for (i=0; i<n; i++) a[i]=random(MaxElem+1);
}

void Kiiras(char *Szoveg, Tomb a, int n)
{ int i;
  printf("%s\n",Szoveg);
  for (i=0; i<n; i++) printf("%d ",a[i]);
  printf("\n");
}

void main(void)
{ Tomb a;
  randomize(); clrscr();

  General(a,MaxElemSzam);
  Kiiras("Rendezs eltt",a,MaxElemSzam);

  /* Sorbarendezs */
  GyorsRend(a,0,MaxElemSzam-1);

  Kiiras("Rendezs utn",a,MaxElemSzam);
}
