{ Gyorsrendezs rekurzvan }
program GYRENDR;
uses crt;
const
  MaxElemSzam=10;            { A rendezend adatok maximlis szma }
  MaxElem=20;                { A generland adatok maximlis rtke }
type
  Elem=integer;                         { A rendezend elemek tpusa }
  Tomb=array[1..MaxElemSzam] of Elem;   { A rendezend elemek tmbje }

{ A rekurzv eljrs amely rendezi az 'a' tmb 'k'-'v' index elemeit }
procedure GyorsRend(var a:Tomb; k,v:integer);
var s,cs:Elem; i,j:integer;
begin
  if k<v then begin
    { Van legalbb kt elem }
    i:=k; j:=v; s:=a[(i+j) div 2];
    { Sztvlogats a strzsa (s) elemhez kpest }
    while i<=j do begin
      while a[i]<s do inc(i);
      while a[j]>s do dec(j);
      if i<=j then begin
	{ Az i. s j. elemek cserje }
	cs:=a[i]; a[i]:=a[j]; a[j]:=cs;
	inc(i); dec(j);
      end;
    end;
    { Az els rsz rendezse rekurzv hvssal }
    GyorsRend(a,k,j);
    { A msodik rsz rendezse rekurzv hvssal }
    GyorsRend(a,i,v);
  end;
end;

{ Elemek generlsa }
procedure General(var a:Tomb; n:integer);
var i:integer;
begin
  for i:=1 to n do
    a[i]:=random(MaxElem+1);
end;

procedure Kiiras(Szoveg:string; const a:Tomb; n:integer);
var i:integer;
begin
  writeln(Szoveg);
  for i:=1 to n do write(a[i],' ');
  writeln;
end;

var a:Tomb;
begin
  randomize; clrscr;

  General(a,MaxElemSzam);
  Kiiras('Rendezs eltt',a,MaxElemSzam);

  { Sorbarendezs }
  GyorsRend(a,1,MaxElemSzam);

  Kiiras('Rendezs utn',a,MaxElemSzam);
end.

