/* HUSZAR.C : Huszr tja a sakktbln */

#include <stdio.h>
#include <conio.h>

#define MaxMeret 8       /* A tbla maximlis mrete */
#define KellKiiras 0     /* Legyen-e kirs a lpsek utn */

typedef struct {
  int S,O;
} Mezo;

/* A lehetsges 8 lpsirny relatv elmozdulsai */
const int LepS[8]={-2,-1,1,2,2,1,-1,-2};
const int LepO[8]={1,2,2,1,-1,-2,-2,-1};

/* Globlis vltozk */
int N;                             /* A tbla mrete */
int Tabla[MaxMeret][MaxMeret];     /* A tbla */
int VanMego;                       /* Van-e mr megolds */

void Kiir(int Lepes)
{ int i,j;
  if (Lepes)
    printf("%d. lps utn\n",Lepes);
  for (i=0; i<N; i++) {
    for (j=0; j<N; j++)
      printf("%4d",Tabla[i][j]);
    printf("\n");
  }; printf("\n");
  getch();
}

/* A huszr kvetkez lpse */
void Probal(int Lepes, Mezo *Akt)
{ int Irany;
  Mezo Kov;
  /* A vlaszts elksztse */
  Irany=0;
  do {
    /* Vlasszuk ki a kvetkez vlasztst */
    Kov.S=(*Akt).S+LepS[Irany];
    Kov.O=(*Akt).O+LepO[Irany];
    /* Megfelel? */
    if (Kov.S>=0 && Kov.S<=N-1 && Kov.O>=0 && Kov.O<=N-1 &&
       Tabla[Kov.S][Kov.O]==0) {
      /* Jegyezzk fel */
      Tabla[Kov.S][Kov.O]=Lepes;
      if (KellKiiras)
	Kiir(Lepes);
      /* A megolds nem teljes? */
      if (Lepes<N*N) {
	/* Rekurzv hvs */
	Probal(Lepes+1,&Kov);
	if (!VanMego)
	  /* A feljegyzs trlse */
	  Tabla[Kov.S][Kov.O]=0;
      } else
	VanMego=1;
    }
    Irany++;
  } while (!VanMego && Irany<8);
}

void main()
{ Mezo Km;
  int i,j;
  clrscr();
  printf("A sakktbla mrete (3-%d):",MaxMeret);
  scanf("%d",&N);
  printf("A kezdmez sora (1-%d):",N);
  scanf("%d",&Km.S); Km.S--;
  printf("A kezdmez oszlopa (1-%d):",N);
  scanf("%d",&Km.O); Km.O--;
  for (i=0; i<N; i++)
    for (j=0; j<N; j++)
      Tabla[i][j]=0;
  Tabla[Km.S][Km.O]=1;
  VanMego=0;

  printf("Dolgozom...\n");

  Probal(2,&Km);

  if (VanMego) {
    printf("\nA megtallt megolds\n");
    Kiir(0);
  } else
    printf("Nincs megolds!\n");
}
