/* KIRALYNO.C : A 8 kirlyn problma */

#include <stdio.h>
#include <conio.h>

#define MaxMeret 8                 /* A tbla maximlis mrete */

/* Globlis vltozk (A tmbk 0. elemeit nem hasznljuk) */
int n;                             /* A tbla mrete */
int Hol[MaxMeret+1];               /* A kirlynk helye */
int FAtl[2*MaxMeret];              /* A ftlk foglaltsga */
int MAtl[2*MaxMeret];              /* A mellktlk foglaltsga */
int Oszl[2*MaxMeret];              /* Az oszlopok foglaltsga */
int db;                            /* Az sszes megolds darabszma */

void SzinValt(int Szoveg, int Hatter)
{ textcolor(Szoveg);
  textbackground(Hatter);
}

void MegoKiir(int Kiiras)
{ int i,j,k;
  db++; printf("%d. megolds\n",db);
  if (Kiiras) {
    /* Sima kirs */
    for (i=1; i<=n; i++) printf("%4d",Hol[i]); printf("\n");
  } else {
    /* Tbls megjelents */
    printf(""); for (k=1; k<=3*n; k++) printf(""); printf("\n");
    for (i=1; i<=n; i++) {
      printf("");
      for (j=1; j<=n; j++) {
	if (i%2==0 && j%2==0 || i%2==1 && j%2==1) SzinValt(0,7);
	else SzinValt(7,0);
	cprintf("   ");
	if (Hol[i]==j) {
	  gotoxy(wherex()-3,wherey()); printf("\\%c/",127);
	}
      }
      SzinValt(7,0); printf("\n");
    }
    printf(""); for (k=1; k<=3*n; k++) printf(""); printf("\n");
  }
  getch();
}

/* Egy kirlyn elhelyezse az S. sorba */
void Probal(int s)
{ int o;
  /* Az sszes vlasztson */
  for (o=1; o<=n; o++) {
    /* s. sorba az o. oszlopba tve az s. kirlynt */
    /* Megfelel? */
    if (!Oszl[o] && !FAtl[s-o+n] && !MAtl[s+o-1]) {
      /* Jegyezzk fel */
      Hol[s]=o;
      Oszl[o]=1;
      FAtl[s-o+n]=1;
      MAtl[s+o-1]=1;
      /* A megolds nem teljes? */
      if (s<n)
	/* Rekurzv hvs */
	Probal(s+1);
      else
	MegoKiir(0);
      /* A feljegyzs trlse */
      Oszl[o]=0;
      FAtl[s-o+n]=0;
      MAtl[s+o-1]=0;
    }
  }
}

void main()
{ int i;
  clrscr();
  printf("A sakktbla mrete (1-%d):",MaxMeret); scanf("%d",&n);
  for (i=1; i<=n; i++)
    Oszl[i]=0;
  for (i=1; i<=2*n-1; i++) {
    FAtl[i]=0; MAtl[i]=0;
  }
  db=0;
  Probal(1);
  if (db==0) printf("Nincs megolds!");
  else printf("%d db megolds ltezett!",db);
}
