/* MATOSSZ.C : Mtrixsszegek */

#include <stdio.h>
#include <conio.h>

#define NMax 10         /* Sorok maximlis szma */
#define MMax 10         /* Oszlopok maximlis szma */

typedef float Matrix[NMax][MMax];     /* A mtrix */
typedef float SorOsszeg[NMax];        /* A sorsszegek */
typedef float OszlOsszeg[NMax];       /* Az oszlopsszegek */

void Osszegek(Matrix a, int n, int m,
	      SorOsszeg Sor, OszlOsszeg Oszl, float *Ossz)
{ int i,j;
  /* Kezdrtkek */
  for (j=0; j<m; j++) Oszl[j]=0;
  *Ossz=0;
  /* sszegzs */
  for (i=0; i<n; i++) {
    Sor[i]=0;
    for (j=0; j<m; j++) {
      Sor[i]+=a[i][j];
      Oszl[j]+=a[i][j];
    }
    *Ossz+=Sor[i];
  }
}

void main(void)
{ Matrix a; SorOsszeg s; OszlOsszeg o; float ossz;
  int n,m,i,j;
  clrscr();
  /* Adatbekrs */
  printf("Sorok szma (1-%d):",NMax); scanf("%d",&n);
  printf("Oszlopok szma (1-%d):",MMax); scanf("%d",&m);
  for (i=0; i<n; i++)
    for (j=0; j<m; j++) {
      printf("%d. sor %d. elem:",i+1,j+1); scanf("%f",&a[i][j]);
    }
  /* A mtrix kirsa mtrix alakban */
  printf("A megadott mtrix\n");
  for (i=0; i<n; i++) {
    for (j=0; j<m; j++) printf("%8.1f",a[i][j]);
    printf("\n");
  }
  /* sszegzs */
  Osszegek(a,n,m,s,o,&ossz);
  /* Eredmnykirs */
  printf("A sorsszegek:\n");
  for (i=0; i<n; i++) printf("%8.1f",s[i]); printf("\n");
  printf("Az oszlopsszegek:\n");
  for (j=0; j<m; j++) printf("%8.1f",o[j]); printf("\n");
  printf("A teljes sszeg:\n%8.1f\n",ossz);
}
