{ Mtrixsszegek }
program MATOSSZ;
uses crt;

const
  NMax=10;   { Sorok maximlis szma }
  MMax=10;   { Oszlopok maximlis szma }

type
  Matrix=array[1..NMax,1..MMax] of real;     { A mtrix }
  SorOsszeg=array[1..NMax] of real;          { A sorsszegek }
  OszlOsszeg=array[1..MMax] of real;         { Az oszlopsszegek }

procedure Osszegek(const a:Matrix; n,m:integer;
 var Sor:SorOsszeg; var Oszl:OszlOsszeg; var Ossz:real);
var i,j:integer;
begin
  { Kezdrtkek }
  for j:=1 to m do Oszl[j]:=0;
  Ossz:=0;
  { sszegzs }
  for i:=1 to n do begin
    Sor[i]:=0;
    for j:=1 to m do begin
      Sor[i]:=Sor[i]+a[i,j];
      Oszl[j]:=Oszl[j]+a[i,j];
    end;
    Ossz:=Ossz+Sor[i];
  end;
end;

var a:Matrix; s:SorOsszeg; o:OszlOsszeg; ossz:real;
    n,m,i,j:integer;
begin
  clrscr;
  { Adatbekrs }
  write('Sorok szma (1-',NMax,'):'); readln(n);
  write('Oszlopok szma (1-',MMax,'):'); readln(m);
  for i:=1 to n do
    for j:=1 to m do begin
      write(i,'. sor ',j,'. elem:'); readln(a[i,j]);
    end;
  { A mtrix kirsa mtrix alakban }
  writeln('A megadott mtrix');
  for i:=1 to n do begin
    for j:=1 to m do write(a[i,j]:8:1);
    writeln;
  end;
  { sszegzs }
  Osszegek(a,n,m,s,o,ossz);
  { Eredmnykirs }
  writeln('A sorsszegek:');
  for i:=1 to n do write(s[i]:8:1); writeln;
  writeln('Az oszlopsszegek:');
  for j:=1 to m do write(o[j]:8:1); writeln;
  writeln('A teljes sszeg:'); writeln(ossz:8:1);
end.
