{ Oszlopok trlse mtrixbl }
program OSZLTORL;
uses crt;

const
  NMax=10;   { Sorok maximlis szma }
  MMax=10;   { Oszlopok maximlis szma }

type
  Matrix=array[1..NMax,1..MMax] of integer;     { A mtrix }

procedure Torol(var a:Matrix; n:integer; var m:integer);
var i,j,k:integer; Egyf:boolean;
begin
  j:=1;
  while j<=m do begin
    { A j. oszlop vizsglata }
    Egyf:=true;
    i:=2;
    while (i<=n) and Egyf do begin
      Egyf:=a[i,j]=a[1,j];
      inc(i);
    end;
    if Egyf then begin
      { A j. oszlop trlse }
      for k:=j+1 to m do
	for i:=1 to n do
	  a[i,k-1]:=a[i,k];
      dec(m);
    end else
      inc(j);
  end;
end;

{ A mtrix kirsa mtrix alakban }
procedure Kiir(const a:Matrix; n,m:integer);
var i,j:integer;
begin
  for i:=1 to n do begin
    for j:=1 to m do write(a[i][j]:6);
    writeln;
  end;
end;

var a:Matrix; n,m,i,j:integer;
begin
  clrscr;
  { Adatbekrs }
  write('Sorok szma (1-',NMax,'):'); readln(n);
  write('Oszlopok szma (1-',MMax,'):'); readln(m);
  for i:=1 to n do
    for j:=1 to m do begin
      write(i,'. sor ',j,'. elem:'); readln(a[i,j]);
    end;
  writeln('A megadott mtrix'); Kiir(a,n,m);
  { Trls }
  Torol(a,n,m);
  writeln('Az eredmny mtrix'); Kiir(a,n,m);
end.
