/* BINKERFA.C : Binris keresfa */

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

typedef int Elem;
struct BinFaPont {
  Elem PontJell;
  struct BinFaPont *BalAg,*JobbAg;
};
typedef struct BinFaPont* BinFaPontMut;

/* Keress binris keresfban */
BinFaPontMut Keres(BinFaPontMut Gyoker, Elem x)
{ BinFaPontMut Akt;
  Akt=Gyoker;
  while (Akt!=NULL && x!=(*Akt).PontJell)
    if (x<(*Akt).PontJell)
      Akt=(*Akt).BalAg;
    else
      Akt=(*Akt).JobbAg;
  return (Akt);
}

/* Binris keresfa bvtse */
void Bovit(BinFaPontMut *Gyoker, BinFaPontMut x)
{ BinFaPontMut Akt,Szulo;
  if (*Gyoker==NULL)
    *Gyoker=x;
  else {
    /* Helykeress */
    Akt=*Gyoker; Szulo=NULL;
    while (Akt!=NULL) {
      Szulo=Akt;
      if ((*x).PontJell<(*Akt).PontJell)
	Akt=(*Akt).BalAg;
      else
	Akt=(*Akt).JobbAg;
    }
    /* Beilleszts */
    if ((*x).PontJell<(*Szulo).PontJell)
      (*Szulo).BalAg=x;
    else
      (*Szulo).JobbAg=x;
  }
}

/* Binris keresfa elemeinek kirsa */
void Kiir(BinFaPontMut Gyoker)
{ if (Gyoker!=NULL) {
    /* Rekurzv hvs a bal gra */
    Kiir((*Gyoker).BalAg);
    /* A gykrponthoz tartoz rtk kirsa */
    printf("%d ",(*Gyoker).PontJell);
    /* Rekurzv hvs a bal gra */
    Kiir((*Gyoker).JobbAg);
  }
}

void main()
{ BinFaPontMut Gyoker,Akt; Elem a; int i;
  clrscr();
  Gyoker=NULL;
  printf("Adatmegads vge:0\n");
  i=1;
  do {
    printf("%d. elem:",i++); scanf("%d",&a);
    if (a!=0) {
      if ((Akt=(BinFaPontMut)malloc(sizeof(struct BinFaPont)))!=NULL) {
	/* Van hely, a keresfba illesszk */
	(*Akt).PontJell=a; (*Akt).BalAg=NULL; (*Akt).JobbAg=NULL;
	Bovit(&Gyoker,Akt);
      }
    }
  } while (a!=0);

  printf("A megadott elemek rendezve:\n");
  Kiir(Gyoker);
  printf("\n");

  printf("A keresett elem:"); scanf("%d",&a);
  if (Keres(Gyoker,a)==NULL)
    printf("Nincs ilyen elem!\n");
  else
    printf("Van ilyen elem!\n");
}
