/* ELOFSTAT.C : Elfordulsi statisztika */

#include <stdio.h>
#include <conio.h>

#define NMax 10                        /* Az adatok maximlis szma */

typedef int Elem;                      /* Az adatsor elemei */
typedef Elem Adatsor[NMax];            /* Az adatsor */
typedef int Dbsor[NMax];               /* A darabszmok */

void Statisztika(Adatsor a, int n, Adatsor t, Dbsor db, int *k)
{ int i,j;
  /* Kezdrtk */
  *k=0;
  for (i=0; i<n; i++) {
    /* Felvtel */
    t[*k]=a[i];
    db[*k]=0;
    (*k)++;
    /* Keress */
    j=0;
    while (a[i]!=t[j]) j++;
    /* Darabszm nvels */
    db[j]++;
    /* Ha volt mr ilyen, trljk a tblzat vgrl */
    if (j<*k-1) (*k)--;
  }
}

void main(void)
{ Adatsor a,t; Dbsor db;
  int n,i,k;
  clrscr();
  printf("Adatok szma (1-%d):",NMax); scanf("%d",&n);
  for (i=0; i<n; i++) {
    printf("%d. adat:",i+1); scanf("%d",&a[i]);
  }
  Statisztika(a,n,t,db,&k);
  printf("A klnbz adatok s darabszmuk:\n");
  for (i=0; i<k; i++)
    printf("%8d%4d db\n",t[i],db[i]);
}
