{ Huszr tja a sakktbln }
program HUSZAR;
uses crt;

const
  MaxMeret=8;            { A tbla maximlis mrete }
  KellKiiras=false;      { Legyen-e kirs a lpsek utn }

type
  Mezo=record
    S,O:integer;
  end;

  Lepesek=array[1..8] of integer;

{ A lehetsges 8 lpsirny relatv elmozdulsai }
const
  LepS:Lepesek=(-2,-1,1,2,2,1,-1,-2);
  LepO:Lepesek=(1,2,2,1,-1,-2,-2,-1);

{ Globlis vltozk }
var
  N:integer;                                          { A tbla mrete }
  Tabla:array[1..MaxMeret,1..MaxMeret] of integer;    { A tbla }
  VanMego:boolean;                                    { Van-e mr megolds }

procedure Kiir(Lepes:integer);
var i,j:integer;
begin
  if Lepes>0 then
    writeln(Lepes,'. lps utn');
  for i:=1 to N do begin
    for j:=1 to N do
      write(Tabla[i,j]:4);
    writeln;
  end; writeln;
  readkey;
end;

{ A huszr kvetkez lpse }
procedure Probal(Lepes:integer; Akt:Mezo);
var Irany:integer; Kov:Mezo;
begin
  { A vlaszts elksztse }
  Irany:=1;
  repeat
    { Vlasszuk ki a kvetkez vlasztst }
    Kov.S:=Akt.S+LepS[Irany];
    Kov.O:=Akt.O+LepO[Irany];
    { Megfelel? }
    if (Kov.S>=1) and (Kov.S<=N) and (Kov.O>=1) and (Kov.O<=N) and
       (Tabla[Kov.S,Kov.O]=0) then begin
      { Jegyezzk fel }
      Tabla[Kov.S,Kov.O]:=Lepes;
      if KellKiiras then
	Kiir(Lepes);
      { A megolds nem teljes? }
      if Lepes<N*N then begin
	{ Rekurzv hvs }
	Probal(Lepes+1,Kov);
	if not VanMego then
	  { A feljegyzs trlse }
	  Tabla[Kov.S,Kov.O]:=0;
      end else
	VanMego:=true;
    end;
    inc(Irany);
  until VanMego or (Irany>8);
end;

var Km:Mezo; i,j:integer;
begin
  clrscr;
  write('A sakktbla mrete (3-',MaxMeret,'):'); readln(N);
  write('A kezdmez sora (1-',N,'):'); readln(Km.S);
  write('A kezdmez oszlopa (1-',N,'):'); readln(Km.O);
  for i:=1 to N do
    for j:=1 to N do
      Tabla[i,j]:=0;
  Tabla[Km.S,Km.O]:=1;
  VanMego:=false;

  writeln('Dolgozom...');

  Probal(2,Km);

  if VanMego then begin
    writeln; writeln('A megtallt megolds');
    Kiir(0);
  end else
    writeln('Nincs megolds!');
end.
