/* JELSTAT.C : Jelstatisztika */

#include <stdio.h>
#include <conio.h>
#include <string.h>

#define NMax 100                  /* A sztring maximlis hossza */

typedef char Sztring[NMax+1];     /* A sztring */
typedef struct {                  /* A gyakorisgi tblzat egy eleme */
	  char Jel;
	  unsigned char Darab;
	} Elem;
typedef	Elem Tabla[255];          /* A gyakorisgi tblzat */

void Statisztika(Sztring s, Tabla t, unsigned char *k)
{ int i; unsigned char kod, db[256];
  /* Kezdrtkek */
  for (i=0; i<=255; i++) db[i]=0;
  /* Darabszmok meghatrozsa */
  for (i=0; i<strlen(s); i++) {
    kod=s[i];
    db[kod]++;
  }
  /* Eredmnytblzat elksztse */
  *k=0;
  for (i=0; i<=255; i++)
    if (db[i]>0) {
      t[*k].Jel=i;
      t[*k].Darab=db[i];
      (*k)++;
    }
}

void main(void)
{ Sztring s; Tabla t; unsigned char i,k;
  clrscr();
  printf("A sztring:"); scanf("%s",&s);
  Statisztika(s,t,&k);
  printf("A klnbz jelek s darabszmuk:\n");
  for (i=0; i<k; i++)
    printf("%c%4d db\n",t[i].Jel,t[i].Darab);
}
