/* KINAI.C : Knai gyrk */

#include <conio.h>
#include <stdio.h>

#define Max 9               /* A gyrk maximlis szma */

int Gyuruk[Max];            /* A gyrk llapota (1:fent, 0:lent) */
int n;                      /* A gyrk szma */
int l=0;                    /* A mozgatsi lpsek szma */

/* A gyrk llapotnak kirsa */
void Kiir(void)
{ int i;
  if (l==0) printf("Kezdllapot\n");
  else printf("%d. lps\n",l);
  for (i=0; i<n; i++)
    printf("%d",Gyuruk[i]);
  printf("\n");
  l++; getch();
}

/* Az n. s a megelz gyrk levtele */
void BalraLe(int n)
{ void Le(int n);
  int i;
  for (i=n; i>=0; i--) Le(i);
}

/* Az n. gyr levtele */
void Le(int n)
{ void Fel(int n);
  if (Gyuruk[n]) {
    if (n>0) {
      Fel(n-1);
      if (n>1) BalraLe(n-2);
    }
    Gyuruk[n]=0;
    Kiir();
  }
}

/* Az n. gyr felttele */
void Fel(int n)
{ if (!Gyuruk[n]) {
    if (n>0) {
      Fel(n-1);
      if (n>1) BalraLe(n-2);
    }
    Gyuruk[n]=1;
    Kiir();
  }
}

void main()
{ int i;
  clrscr();
  printf("A gyrk szma (1-%d):",Max);
  scanf("%d",&n);

  /* Kezdllapot */
  for (i=0; i<n; i++) Gyuruk[i]=1;
  Kiir();

  /* A f eljrs meghvsa */
  BalraLe(n-1);
}
