{ Egy- s ktirnyban lncolt listk }
program LISTAK;
uses crt;
type
  Elem=integer;
  LancElem1Mut=^LancElem1;
  LancElem1=record
    Adat:Elem;
    Koveto:LancElem1Mut;
  end;
  LancElem2Mut=^LancElem2;
  LancElem2=record
    Adat:Elem;
    Elozo,Koveto:LancElem2Mut;
  end;

{ Keress egy egyirnyban lncolt, rendezetlen listban }
function Kereses1(Elso:LancElem1Mut; x:Elem):LancElem1Mut;
var Akt:LancElem1Mut;
begin
  Akt:=Elso;
  while (Akt<>nil) and (Akt^.Adat<>x) do
    Akt:=Akt^.Koveto;
  Kereses1:=Akt;
end;

{ Keress egy egyirnyban lncolt, rendezett listban }
function KeresesRend1(Elso:LancElem1Mut; x:Elem):LancElem1Mut;
var Akt:LancElem1Mut;
begin
  Akt:=Elso;
  while (Akt<>nil) and (Akt^.Adat<x) do
    Akt:=Akt^.Koveto;
  if (Akt<>nil) and (Akt^.Adat>x) then
    Akt:=nil;
  KeresesRend1:=Akt;
end;

{ Egy egyirnyban lncolt, rendezett lista bvtse egy j listaelemmel }
procedure ListaraRend1(var Elso:LancElem1Mut; Uj:LancElem1Mut);
var Akt,Miutan:LancElem1Mut;
begin
  { Keress }
  Akt:=Elso; Miutan:=nil;
  while (Akt<>nil) and (Akt^.Adat<Uj^.Adat) do begin
    Miutan:=Akt;
    Akt:=Akt^.Koveto;
  end;
  { Beilleszts }
  if Elso=nil then begin
    { res listra }
    Uj^.Koveto:=nil;
    Elso:=Uj;
  end else if Miutan=nil then begin
    { Nem res lista elejre }
    Uj^.Koveto:=Elso;
    Elso:=Uj;
  end else if Akt=nil then begin
    { A lista vgre, a Miutan utn }
    Uj^.Koveto:=nil;
    Miutan^.Koveto:=Uj;
  end else begin
    { A Miutan s az Akt kz }
    Uj^.Koveto:=Miutan^.Koveto;
    Miutan^.Koveto:=Uj;
  end;
end;

{ Beilleszts egy ktirnyban lncolt lista vgre }
procedure Listara2(var Elso,Utolso:LancElem2Mut; Uj:LancElem2Mut);
begin
  if Elso=nil then begin
    { res listra }
    Uj^.Elozo:=nil;
    Uj^.Koveto:=nil;
    Elso:=Uj;
    Utolso:=Uj;
  end else begin
    { Az Utolso utn }
    Uj^.Elozo:=Utolso;
    Uj^.Koveto:=nil;
    Utolso^.Koveto:=Uj;
    Utolso:=Uj;
  end;
end;

{ Elem trlse egy ktirnyban lncolt listbl }
procedure Listarol2(var Elso,Utolso:LancElem2Mut; Mit:LancElem2Mut);
begin
  { Kikapcsols }
  if (Mit=Elso) and (Mit=Utolso) then begin
    { Egyetlen elem }
    Elso:=nil;
    Utolso:=nil;
  end else if Mit=Elso then begin
    { Els, de nem egyetlen }
    Mit^.Koveto^.Elozo:=nil;
    Elso:=Mit^.Koveto;
  end else if Mit=Utolso then begin
    { Utols, de nem egyetlen }
    Mit^.Elozo^.Koveto:=nil;
    Utolso:=Mit^.Elozo;
  end else begin
    { Bels elem }
    Mit^.Elozo^.Koveto:=Mit^.Koveto;
    Mit^.Koveto^.Elozo:=Mit^.Elozo;
  end;
  { Megszntets }
  dispose(Mit);
end;

var Elso1,Akt1:LancElem1Mut;
    Elso2,Utolso2,Akt2:LancElem2Mut;
    a:Elem; i:integer;
begin
  clrscr;
  Elso1:=nil;
  writeln('Adatmegads vge:0');
  i:=1;
  repeat
    write(i,'. elem:'); readln(a); inc(i);
    if a<>0 then begin
      if sizeof(LancElem1)<=maxavail then begin
	{ Van hely a rendezett lncba illesszk }
        new(Akt1);
	Akt1^.Adat:=a;
	ListaraRend1(Elso1,Akt1);
      end;
    end;
  until a=0;

  writeln('A megadott elemek rendezve:');
  Akt1:=Elso1; i:=1;
  while Akt1<>nil do begin
    writeln(i,'. elem:',Akt1^.Adat);
    Akt1:=Akt1^.Koveto;
    inc(i);
  end;

  write('A keresett elem:'); readln(a);
  if Kereses1(Elso1,a)=nil then
    writeln('Nincs ilyen!')
  else
    writeln('Van ilyen!');
  if KeresesRend1(Elso1,a)=nil then
    writeln('Nincs ilyen!')
  else
    writeln('Van ilyen!');

  { A foglalt hely felszabadtsa }
  while Elso1<>nil do begin
    Akt1:=Elso1;
    Elso1:=Elso1^.Koveto;
    dispose(Akt1);
  end;

  Elso2:=nil; Utolso2:=nil;
  writeln('Adatmegads vge:0');
  i:=1;
  repeat
    write(i,'. elem:'); readln(a); inc(i);
    if a<>0 then begin
      if sizeof(LancElem2)<=maxavail then begin
	{ Van hely, a lnc vgre illesszk }
        new(Akt2);
	Akt2^.Adat:=a;
	Listara2(Elso2,Utolso2,Akt2);
      end;
    end;
  until a=0;

  writeln('A megadott elemek eredeti sorrendben:');
  Akt2:=Elso2; i:=1;
  while Akt2<>nil do begin
    writeln(i,'. elem:',Akt2^.Adat);
    Akt2:=Akt2^.Koveto;
    inc(i);
  end;

  writeln('A megadott elemek fordtott sorrendben:');
  Akt2:=Utolso2; i:=1;
  while Akt2<>nil do begin
    writeln(i,'. elem:',Akt2^.Adat);
    Akt2:=Akt2^.Elozo;
    inc(i);
  end;

  { A foglalt hely felszabadtsa (lehetne az utols trlsvel is) }
  while Elso2<>nil do
    Listarol2(Elso2,Utolso2,Elso2);
end.
