/* LNKO.C : Kt termszetes szm legnagyobb kzs osztjnak meghatrozsa */

#include <stdio.h>
#include <conio.h>

/* Nem rekurzv fggvny osztssal */
int lnko_o(int a, int b)
{ int r;
  while (b!=0) {
    r=a%b; a=b; b=r;
  }
  return (a);
}

/* Nem rekurzv fggvny kivonssal */
int lnko_k(int a, int b)
{ while (a!=b)
    if (a>b) a=a-b; else b=b-a;
  return (a);
}

/* Rekurzv fggvny osztssal */
int lnko_ro(int a, int b)
{ int er;
  if (b==0)
    er=a;
  else
    er=lnko_ro(b,a%b);
  return (er);
}

/* Rekurzv fggvny kivonssal */
int lnko_rk(int a, int b)
{ int er;
  if (a==b)
    er=a;
  else if (a>b)
    er=lnko_rk(a-b,b);
  else
    er=lnko_rk(a,b-a);
  return (er);
}

void main()
{ int a,b;
  clrscr();
  printf("Egyik termszetes szm:"); scanf("%d",&a);
  printf("Msik termszetes szm:"); scanf("%d",&b);
  printf("A legnagyobb kzs oszt:\n");
  printf("%d %d %d %d\n",lnko_o(a,b),lnko_k(a,b),lnko_ro(a,b),lnko_rk(a,b));
}
