/* MINHELY.C : Minimumhelyek keresse */

#include <stdio.h>
#include <conio.h>

#define NMax 10                         /* Az adatok maximlis szma */

typedef int Elem;                       /* Az adatsor elemei */
typedef Elem Adatsor[NMax];             /* Az adatsor */
typedef int MinHelyek[NMax];            /* A minimumhelyek */

void MinKereses(const Adatsor a, int n, Elem *Min, int *db, MinHelyek Hely)
{ int i;
  /* Minimum meghatrozsa */
  *Min=a[0];
  for (i=1; i<n; i++)
    if (a[i]<*Min)
      *Min=a[i];
  /* Minimumhelyek */
  *db=0;
  for (i=0; i<n; i++)
    if (a[i]==*Min) {
      Hely[*db]=i;
      (*db)++;
    }
}

void main(void)
{ Adatsor a; MinHelyek Hely;
  int n,i,db; Elem Min;
  clrscr();
  printf("Adatok szma (1-%d):",NMax); scanf("%d",&n);
  for (i=0; i<n; i++) {
    printf("%d. adat:",i+1); scanf("%d",&a[i]);
  }
  MinKereses(a,n,&Min,&db,Hely);
  printf("A legkisebb elem:%d\n",Min);
  printf("Elfordulsi hely(ek):\n");
  for (i=0; i<db; i++)
    printf("%4d\n",Hely[i]+1);
}
