{ Minimumhelyek keresse }
program MINHELY;
uses crt;

const
  NMax=10;                                { Az adatok maximlis szma }
type
  Elem=integer;                           { Az adatsor elemei }
  Index=1..NMax;                          { Az indexek tpusa }
  Adatsor=array[Index] of Elem;           { Az adatsor }
  MinHelyek=array[Index] of Index;        { A minimumhelyek }

procedure MinKereses(const a:Adatsor; n:integer; var Min:Elem;
 var db:integer; var Hely:MinHelyek);
var i:integer;
begin
  { Minimum meghatrozsa }
  Min:=a[1];
  for i:=2 to n do
    if a[i]<Min then
      Min:=a[i];
  { Minimumhelyek }
  db:=0;
  for i:=1 to n do
    if a[i]=Min then begin
      inc(db);
      Hely[db]:=i;
    end;
end;

var a:Adatsor; Hely:MinHelyek;
    n,i,db:integer; Min:Elem;
begin
  clrscr;
  write('Adatok szma (1-',NMax,'):'); readln(n);
  for i:=1 to n do begin
    write(i,'. adat:'); readln(a[i]);
  end;
  MinKereses(a,n,Min,db,Hely);
  writeln('A legkisebb elem:',Min);
  writeln('Elfordulsi hely(ek):');
  for i:=1 to db do
    writeln(Hely[i]:4);
end.
