/* OSZLTORL.C : Oszlopok trlse mtrixbl */

#include <stdio.h>
#include <conio.h>

#define NMax 10         /* Sorok maximlis szma */
#define MMax 10         /* Oszlopok maximlis szma */

typedef int Matrix[NMax][MMax];     /* A mtrix */

void Torol(Matrix a, int n, int *m)
{ int i,j,k,Egyf;
  j=0;
  while (j<*m) {
    /* A j. oszlop vizsglata */
    Egyf=1;
    i=1;
    while (i<n && Egyf) {
      Egyf=a[i][j]==a[0][j];
      i++;
    }
    if (Egyf) {
      /* A j. oszlop trlse */
      for (k=j+1; k<*m; k++)
	for (i=0; i<n; i++)
	  a[i][k-1]=a[i][k];
      (*m)--;
    } else
      j++;
  }
}

/* A mtrix kirsa mtrix alakban */
void Kiir(Matrix a, int n, int m)
{ int i,j;
  for (i=0; i<n; i++) {
    for (j=0; j<m; j++) printf("%6d",a[i][j]);
    printf("\n");
  }
}

void main(void)
{ Matrix a; int n,m,i,j;
  clrscr();
  /* Adatbekrs */
  printf("Sorok szma (1-%d):",NMax); scanf("%d",&n);
  printf("Oszlopok szma (1-%d):",MMax); scanf("%d",&m);
  for (i=0; i<n; i++)
    for (j=0; j<m; j++) {
      printf("%d. sor %d. elem:",i+1,j+1); scanf("%d",&a[i][j]);
    }
  printf("A megadott mtrix\n"); Kiir(a,n,m);
  /* Trls */
  Torol(a,n,&m);
  printf("Az eredmny mtrix\n"); Kiir(a,n,m);
}
