/* STRKIF.C : Sztringben lv egyszer kifejezs kirtkelse */

#include <stdio.h>
#include <conio.h>
#include <string.h>

#define MaxHossz 100         /* A sztring maximlis hossza */

typedef char Sztring[MaxHossz+1];      /* A sztring, mint karaktertmb */

void Ertekel(Sztring s, int *jo, int *er)
{ int h,i;
  /* Hosszellenrzs */
  h=strlen(s);
  *jo=h%2==1;
  if (jo) {
    /* Karakterek ellenrzse */
    i=0;
    while (i<h && *jo)
      /* A pros/pratlan pozci pp fordtva, mert 0-tl indexelnk */
      if (i%2==0 && (s[i]<'0' || s[i]>'9') ||
	 (i%2==1 && s[i]!='+' && s[i]!='-'))
	 *jo=0;
      else i++;
    if (*jo) {
      /* A kifejezs rtknek kiszmtsa */
      *er=s[0]-'0';
      i=2;
      while (i<h) {
	if (s[i-1]=='+')
	  *er+=s[i]-'0';
	else
	  *er-=s[i]-'0';
	i+=2;
      }
    }
  }
}

void main(void)
{ Sztring s; int jo,er;
  clrscr();
  printf("A kirtkelend kifejezs:"); scanf("%s",&s);
  Ertekel(s,&jo,&er);
  if (jo)
    printf("Helyes kifejezs, rtke:%d\n",er);
  else
    printf("Hibs kifejezs!\n");
}
