{ Trgymutat }
program TARGYMUT;
uses crt;
const
  MaxSzoHossz=20;                         { A szavak maximlis hossza }
type
  TSzo=string[MaxSzoHossz];               { A szavak tpusa }
  THiv=word;                              { A hivatkozsok tpusa }

  HivRekMut=^HivRek;                      { A hivatkozsrekordra mutat }
  HivRek=record                           { A hivatkozsrekord }
    Oldal:THiv;
    Kov:HivRekMut;
  end;

  SzoRekMut=^SzoRek;                      { A szrekordra mutat }
  SzoRek=record                           { A szrekord }
    Szo:TSzo;
    EHiv,UHiv:HivRekMut;
    Kov:SzoRekMut;
  end;

{ j szrekord ltrehozsa }
function UjSzoRek(Szo:TSzo; Oldal:THiv; KovSzo:SzoRekMut):SzoRekMut;
var UjSzo:SzoRekMut; UjHiv:HivRekMut;
begin
  new(UjSzo);
  UjSzo^.Szo:=Szo;
  UjSzo^.Kov:=KovSzo;
  new(UjHiv);
  UjSzo^.EHiv:=UjHiv;
  UjSzo^.UHiv:=UjHiv;
  UjHiv^.Oldal:=Oldal;
  UjHiv^.Kov:=nil;
  UjSzoRek:=UjSzo;
end;

{ A trgymutat bvtse }
procedure Bovit(var TMKezd:SzoRekMut; Szo:TSzo; Oldal:THiv);
var Akt,Elozo:SzoRekMut; UjHiv:HivRekMut;
begin
  if TMKezd=nil then
    { res a trgymutat }
    TMKezd:=UjSzoRek(Szo,Oldal,nil)
  else begin
    { Keress }
    Akt:=TMKezd;
    Elozo:=nil;
    while (Akt^.Szo<Szo) and (Akt^.Kov<>nil) do begin
      Elozo:=Akt;
      Akt:=Akt^.Kov;
    end;
    if Akt^.Szo<Szo then
      { Vgre j sz }
      Akt^.Kov:=UjSzoRek(Szo,Oldal,nil)
    else if Akt^.Szo>Szo then
      { Az Akt s az Elozo kz j sz }
      if Elozo=nil then
    	{ A lista elejre }
	    TMKezd:=UjSzoRek(Szo,Oldal,TMKezd)
      else
	    { A lista belsejbe }
	    Elozo^.Kov:=UjSzoRek(Szo,Oldal,Akt)
    else begin
      { Meglv sz (Akt) j hivatkozsa }
      new(UjHiv);
      UjHiv^.Oldal:=Oldal;
      UjHiv^.Kov:=nil;
      Akt^.UHiv^.Kov:=UjHiv;
      Akt^.UHiv:=UjHiv;
    end;
  end;
end;

{ A trgymutat adatainak kirsa a kpernyre }
procedure Kiir(TMKezd:SzoRekMut);
var Akt:SzoRekMut; AktHiv:HivRekMut;
begin
  Akt:=TMKezd;
  while Akt<>nil do begin
    write(Akt^.Szo,'':MaxSzoHossz-length(Akt^.Szo));
    AktHiv:=Akt^.EHiv;
    while AktHiv<>nil do begin
      write(AktHiv^.Oldal:6);
      AktHiv:=AktHiv^.Kov;
    end;
    writeln; readkey;
    Akt:=Akt^.Kov;
  end;
end;

var TMKezd:SzoRekMut; VanHely,Vege:boolean;
    Szo:TSzo; Hiv:THiv;
begin
  clrscr;
  TMKezd:=nil;
  { Feltlts input adatokkal }
  writeln('A trgymutat adatai (Kilps:"*" sz)\n');
  repeat
    { Lesz majd elg hely? }
    VanHely:=sizeof(SzoRek)+sizeof(HivRek)<=memavail;
    if VanHely then begin
      { Igen }
      write('Sz:'); readln(Szo);
      Vege:=Szo='*';
      if not Vege then begin
	write('Hivatkozs:'); readln(Hiv);
	Bovit(TMKezd,Szo,Hiv);
      end;
    end;
  until Vege or not VanHely;
  { Kirs }
  if TMKezd=nil then
    writeln('Nem adott meg adatokat!')
  else begin
    writeln('A trgymutat:');
    Kiir(TMKezd);
  end;
end.
