{ Tpusos fjl rekordjainak rendezse sszefslssel }
program TIPFREND;
uses crt;
const
  fnev1='adatokp1.dta';     { A rendezend adatok }
  fnev2='adatokp2.dta';     { Segdfjl }
  fnev3='adatokp3.dta';     { Segdfjl }

  MaxElemSzam=10;           { A generlt adatok maximlis szma }
  MaxElem=20;               { A generlt adatok maximlis rtke }
type
  TAdat=record              { A rendezend rekordok }
    A:integer;              { Ezen mez szerint rendeznk }
  end;
  AdatFajl=file of TAdat;   { Az adatfjl }

{ A fjlmutatt egy rekorddal vissza }
procedure Vissza(var f:AdatFajl);
begin
  seek(f,filepos(f)-1);
end;

{ Fjlvgn llunk-e }
function FajlVege(var f:AdatFajl):boolean;
begin
  FajlVege:=eof(f);
end;

function LancVege(var Miben:AdatFajl; const Akt:TAdat):boolean;
var Kov:TAdat; Er:boolean;
begin
  if FajlVege(Miben) then Er:=true
  else begin
    read(Miben,Kov);
    Vissza(Miben);
    Er:=Kov.A<Akt.A;
  end;
  LancVege:=Er;
end;

procedure LancMasol(var Bol,Ba:AdatFajl);
var Akt:TAdat;
begin
  repeat
    read(Bol,Akt); write(Ba,Akt);
  until LancVege(Bol,Akt);
end;

procedure Rendezes;
var a,b,c:AdatFajl;
    LancDb:integer; LancVeg:boolean;
    akt_a,akt_b:TAdat;
begin
  assign(c,fnev1); assign(a,fnev2); assign(b,fnev3);
  repeat
    { Sztoszts }
    reset(c); rewrite(a); rewrite(b);
    while not FajlVege(c) do begin
      LancMasol(c,a);
      if not FajlVege(c) then
	LancMasol(c,b);
    end;
    close(a); close(b); close(c);
    { sszefsls }
    rewrite(c); reset(a); reset(b);
    LancDb:=0;
    while not FajlVege(a) and not FajlVege(b) do begin
      { Egy lnc sszefslse }
      read(a,akt_a); read(b,akt_b);
      repeat
	if akt_a.A<=akt_b.A then begin
	  { a-bl egy elemet }
	  write(c,akt_a);
	  LancVeg:=LancVege(a,akt_a);
	  if LancVeg then begin
	    Vissza(b);
	    LancMasol(b,c);
	  end else
	    read(a,akt_a);
	end else begin
	  { b-bl egy elemet }
	  write(c,akt_b);
	  LancVeg:=LancVege(b,akt_b);
	  if LancVeg then begin
	    Vissza(a);
	    LancMasol(a,c);
	  end else
	    read(b,akt_b);
	end;
      until LancVeg;
      inc(LancDb);
    end;
    { Maradkok msolsa }
    if not FajlVege(a) then begin
      while not FajlVege(a) do begin
	read(a,akt_a);
	write(c,akt_a);
      end;
      inc(LancDb);
    end;
    if not FajlVege(b) then begin
      while not FajlVege(b) do begin
	read(b,akt_b);
	write(c,akt_b);
      end;
      inc(LancDb);
    end;
    close(a); close(b); close(c);
  until LancDb<=1;
end;

var f:AdatFajl; Adat:TAdat;
    i,db:integer;
begin
  { Vletlen elemgenerls }
  randomize; clrscr;
  writeln('Rendezs eltt');
  assign(f,fnev1);
  rewrite(f);
  for i:=1 to MaxElemSzam do begin
    Adat.A:=random(MaxElem+1);
    write(f,Adat);
    write(Adat.A,' ');
  end; writeln;
  close(f);

  { Sorbarendezs }
  Rendezes;

  { Eredmnykirs }
  writeln('Rendezs utn');
  reset(f);
  while not FajlVege(f) do begin
    read(f,Adat);
    write(Adat.A,' ');
  end; writeln;
  close(f);

  { Munkafjlok trlse }
  assign(f,fnev2); erase(f);
  assign(f,fnev3); erase(f);
end.
