/* TOMBKIIR.C : Adatsor megjelentse */

#include <conio.h>
#include <stdio.h>

#define Esc  27               /* A megengedett billentyk */
#define Home 71
#define End  79
#define Down 80
#define Up   72
#define PgUp 73
#define PgDn 81

#define Max 256               /* Karakterhalmazok maximlis elemszma */
typedef int Jelek[Max];

#define NMax 10                         /* Az adatok maximlis szma */
typedef int Elem;                       /* Az adatsor elemei */
typedef Elem Adatsor[NMax];             /* Az adatsor */

int BillBe(int *Normal, int *Dupla, int *Duplae)
{ int Jel,JoJel;
  do {
    Jel=getch(); *Duplae=Jel==0;
    if (*Duplae) {
      Jel=getch();
      JoJel=Dupla[Jel];
    } else
      JoJel=Normal[Jel];
  } while (!JoJel);
  return (Jel);
}

void Ures(int *Jelek)
{ int i;
  for (i=0; i<Max; i++) Jelek[i]=0;
}

void Bovit1(int *Mit, int Mivel)
{ Mit[Mivel]=1;
}

void Kiir(Adatsor a, int n, int db)
{ int Kezd,Bef,i,Jel,Duplae; Jelek Normal,Dupla;
  if (n==0) {
    clrscr(); printf("Nincsenek elemek!\n"); getch();
  } else {
    Kezd=0;
    do {
      /* A befejez index belltsa */
      Bef=Kezd+db-1; if (Bef>n-1) Bef=n-1;
      /* Adatkirs */
      clrscr(); printf("Ssz. Elem\n");
      for (i=Kezd; i<=Bef; i++) printf("%3d. %d\n",i+1,a[i]);
      /* Az elfogadhat jelek belltsa */
      Ures(Normal); Bovit1(Normal,Esc); Ures(Dupla);
      if (Kezd>0) {
	Bovit1(Dupla,Home); Bovit1(Dupla,Up); Bovit1(Dupla,PgUp);
      }
      if (Bef<n-1) {
	Bovit1(Dupla,End); Bovit1(Dupla,Down); Bovit1(Dupla,PgDn);
      }
      /* Billentyzetrl val bekrs */
      Jel=BillBe(Normal,Dupla,&Duplae);
      /* Pozcionls */
      if (Jel==Home) Kezd=0;
      else if (Jel==End) Kezd=n-db;
      else if (Jel==PgDn)
	if (Bef<n-db) Kezd+=db; else Kezd=n-db;
      else if (Jel==PgUp)
	if (Kezd-db>=0) Kezd-=db; else Kezd=0;
      else if (Jel==Down) Kezd++;
      else if (Jel==Up) Kezd--;
    } while (Jel!=Esc);
  }
}

void main(void)
{ Adatsor a;
  int n,db,i;
  clrscr();
  printf("Adatok szma (0-%d):",NMax); scanf("%d",&n);
  for (i=0; i<n; i++) {
    printf("%d. adat:",i+1); scanf("%d",&a[i]);
  }
  printf("Egy kpernyn lv adatok szma (1-%d):",NMax); scanf("%d",&db);
  Kiir(a,n,db);
}

