{ Adatsor megjelentse }
program TOMBKIIR;
uses crt;
const                             { A megengedett billentyk }
  Esc=#27;
  Home=#71; End_=#79;
  Down=#80; Up=#72;
  PgUp=#73; PgDn=#81;
const
  NMax=10;                                { Az adatok maximlis szma }
type
  Elem=integer;                           { Az adatsor elemei }
  Adatsor=array[1..NMax] of Elem;         { Az adatsor }
  Jelek=set of char;

function BillBe(Normal,Dupla:Jelek; var Duplae:Boolean):char;
var Jel:char; JoJel:boolean;
begin
  repeat
    Jel:=readkey; Duplae:=Jel=#0;
    if Duplae then begin
      Jel:=readkey;
      JoJel:=Jel in Dupla;
    end else
      JoJel:=Jel in Normal;
  until JoJel;
  BillBe:=Jel;
end;

procedure Kiir(const a:Adatsor; n,db:integer);
var Kezd,Bef,i:integer;
    Jel:char; Normal,Dupla:Jelek; Duplae:boolean;
begin
  if n=0 then begin
    clrscr; writeln('Nincsenek elemek!'); readkey;
  end else begin
    Kezd:=1;
    repeat
      { A befejez index belltsa }
      Bef:=Kezd+db-1; if Bef>n then Bef:=n;
      { Adatkirs }
      clrscr; writeln('Ssz. Elem');
      for i:=Kezd to Bef do writeln(i:3,'. ',a[i]);
      { Az elfogadhat jelek belltsa }
      Normal:=[Esc]; Dupla:=[];
      if Kezd>1 then Dupla:=Dupla+[Home,Up,PgUp];
      if Bef<n then Dupla:=Dupla+[End_,Down,PgDn];
      { Billentyzetrl val bekrs }
      Jel:=BillBe(Normal,Dupla,Duplae);
      { Pozcionls }
      case Jel of
        Home:Kezd:=1;
        End_:Kezd:=n-db+1;
        PgDn:if Bef<n-db+1 then inc(Kezd,db) else Kezd:=n-db+1;
        PgUp:if Kezd-db>=1 then dec(Kezd,db) else Kezd:=1;
        Down:inc(Kezd);
        Up  :dec(Kezd);
      end;
    until Jel=Esc;
  end;
end;

var a:Adatsor;
    n,db,i:integer;
begin
  clrscr;
  write('Adatok szma (0-',NMax,'):'); readln(n);
  for i:=1 to n do begin
    write(i,'. adat:'); readln(a[i]);
  end;
  write('Egy kpernyn lv adatok szma (1-',NMax,'):'); readln(db);
  Kiir(a,n,db);
end.
